"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var events_1 = require("events");
var KeepAliveToken = (function (_super) {
    __extends(KeepAliveToken, _super);
    function KeepAliveToken(handler, lease, interval) {
        var _this = this;
        if (interval === void 0) { interval = 1000; }
        _super.call(this);
        this.handler = handler;
        this.lease = lease;
        if (interval == null)
            interval = 1000;
        this.intervalId = setInterval(function () {
            try {
                _this.handler.write({
                    ID: _this.lease
                });
            }
            catch (err) {
                console.error("etcd lease keep alive write error, lease: " + _this.lease);
                _this.cancel();
            }
        }, interval);
        // handler.on("data", (data) => {})
        /*this.handler.on("end", () => {
            console.error(`etcd lease keep alive end, lease: ${this.lease}`);
            this.handler.cancel();
            this.cancel();
        });*/
    }
    KeepAliveToken.prototype.cancel = function () {
        clearInterval(this.intervalId);
        this.handler.end();
    };
    return KeepAliveToken;
}(events_1.EventEmitter));
exports.KeepAliveToken = KeepAliveToken;
;
